/* sw_spvpe.c - spawn a child process.
   Copyright (C) 1990 by Thorsten Ohl, td12@ddagsi3.bitnet

   This file is part of SWAPLIB (the library), a library for efficient
   execution of child processes under MS-DOS.

   The library is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   The library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with the library; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   $Header: e:/gnu/swaplib/RCS/sw_spvpe.c'v 0.9 90/09/09 21:44:21 tho Stable $
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "swaplib.h"

int
swap_spawnvpe (char *cmd, char **argv, char **envvec)
{
  int rc;
  char *command = swap_expand_path (cmd, "PATH", swap_executable_p);

  if (!command)
    {
      errno = ENOENT;
      return -1;
    }

  rc = swap_spawnve (command, argv, envvec);

  if (command)
    free (command);

  return rc;
}

/* 
 * Local Variables:
 * mode:C
 * ChangeLog:ChangeLog
 * compile-command:make
 * End:
 */
